Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSDefineJPEGImage2

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSDefineObject
                  com.flagstone.transform.FSDefineJPEGImage2

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSDefineJPEGImage2

extends FSDefineObject

FSDefineJPEGImage2 is used to define a JPEG encoded image with an integrated encoding table.

It extends the FSDefineJPEGImage class by including a separate encoding table, rather than using an FSJPEGEncodingTable object to store the encoding table. This allows multiple JPEG images with different amounts of compression to be included within a Flash file.

Attributes
type | Identifies the data structure when it is encoded. Read-only.
identifier | A unique identifier, in the range 1..65535, that is used to reference the image from other objects.
image | An array of bytes containing the JPEG compressed image.
encodingTable | An array of bytes containing the encoding table. May be set to null.

Although the encoding table defines how the image is compressed it is not essential. If an FSDefineJPEGImage3 object is created with an empty encoding table then the Flash Player will still display the JPEG image correctly. The empty encoding table is not a null object. It contains four bytes: 0xFF, 0xD8, 0xFF, 0xD9. For convenience passing a null reference to any of the constructors or to the setEncodingTable method will create an empty table.

# Examples

The simplest way to use the FSDefineJPEGImage2 class is to use the constructor that specifies the JPEG file to initialise the object:

     File aFile = new File(filename);
     byte[] bytes = new byte[(int) aFile.length()];

     try
     {
            FileInputStream imageContents = new FileInputStream(aFile);
            imageContents.read(bytes);
            imageContents.close();
     } catch (FileNotFoundException e)
     {
            throw new FileNotFoundException(filename);
     } catch (IOException e)
     {
            throw new IOException(filename);
     }

     movie.add(new FSDefineJPEGImage2(movie.newIdentifier(), bytes));

This generates an object with an empty encoding table, however the image will still be displayed correctly.

# History

The FSDefineJPEGImage2 class represents the DefineBitsJPEG2 tag from the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 2.

Field Summary

Fields inherited from class com.flagstone.transform.FSDefineObject
`identifier`

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSDefineJPEGImage2(FSCoder coder)` Construct an FSDefineJPEGImage2 object, initialising it with values decoded from an encoded object.
`FSDefineJPEGImage2(FSDefineJPEGImage2 obj)` Constructs an FSDefineJPEGImage2 object by copying values from an existing object.
`FSDefineJPEGImage2(int anIdentifier, byte[] imageBytes)` Constructs an FSDefineJPEGImage2 object with the identifier, JPEG image data and JPEG encoding table data.
`FSDefineJPEGImage2(int anIdentifier, byte[] imageBytes, byte[] encodingBytes)` Constructs an FSDefineJPEGImage2 object with the identifier, JPEG image data and JPEG encoding table data.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`byte[]` | `getEncodingTable()` Gets the encoding table.
`int` | `getHeight()` Gets the height of the image in pixels.
`byte[]` | `getImage()` Gets the image data.
`int` | `getWidth()` Gets the width of the image in pixels.
`int` | `length(FSCoder coder)`
`void` | `setEncodingTable(byte[] bytes)` Sets the encoding table.
`void` | `setImage(byte[] bytes)` Sets the image data.

Methods inherited from class com.flagstone.transform.FSDefineObject
`getIdentifier, setIdentifier`

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSDefineJPEGImage2

    public FSDefineJPEGImage2(FSCoder coder)

  Construct an FSDefineJPEGImage2 object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSDefineJPEGImage2

    public FSDefineJPEGImage2(int anIdentifier,
                              byte[] imageBytes,
                              byte[] encodingBytes)

  Constructs an FSDefineJPEGImage2 object with the identifier, JPEG image data and JPEG encoding table data.

  Parameters:
    `anIdentifier` - the unique identifier for this object
    `imageBytes` - the JPEG encoded image data.
    `encodingBytes` - the JPEG encoded encoding table.

### FSDefineJPEGImage2

    public FSDefineJPEGImage2(int anIdentifier,
                              byte[] imageBytes)

  Constructs an FSDefineJPEGImage2 object with the identifier, JPEG image data and JPEG encoding table data.

  Parameters:
    `anIdentifier` - the unique identifier for this object
    `imageBytes` - the JPEG encoded image data.

### FSDefineJPEGImage2

    public FSDefineJPEGImage2(FSDefineJPEGImage2 obj)

  Constructs an FSDefineJPEGImage2 object by copying values from an existing object.

  Parameters:
    `obj` - an FSDefineJPEGImage2 object.

Method Detail

### getWidth

    public int getWidth()

  Gets the width of the image in pixels.

  Returns:
    the width of the image.

### getHeight

    public int getHeight()

  Gets the height of the image in pixels.

  Returns:
    the height of the image in pixels.

### getImage

    public byte[] getImage()

  Gets the image data.

  Returns:
    the array of bytes containing the image data.

### getEncodingTable

    public byte[] getEncodingTable()

  Gets the encoding table.

  Returns:
    the array of bytes containing the encoding table.

### setImage

    public void setImage(byte[] bytes)

  Sets the image data.

  Parameters:
    `bytes` - an array of bytes containing the image data.

### setEncodingTable

    public void setEncodingTable(byte[] bytes)

  Sets the encoding table.

  Parameters:
    `bytes` - an array of bytes containing the encoding table.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSDefineObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSDefineObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSDefineObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSDefineObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD